      subroutine prelim
c     version as of 3/19/88.
c
c     ******************************************************************
c     do preliminary calculations for kinematics & coulomb
c     ******************************************************************
c
      implicit none

      include 'mai1_com.inc'
      include 'mai2_com.inc'
c
      real*8 amu,aksq,grel,xemp,xem,xemt
      real*8 aux,wcm,temp,x,wm,wmp,aknn


      real*8 amen
      data amen/931.47d0/
c
c     constants used below are ---
c
c     .047846 = 2 * ( 1 amu ) / (hbar) ** 2
c     .034447 = (1 amu) * e ** 2 / (hbar) ** 2
c

      
      
      amu=emp*em/(emp+em)
      emu=.047846d0*amu
     
c
c     choose between relativistic and nonrelativistic kinematics.
c
      if(irel.ne.0) go to 5
c
c     nonrelativistic kinematics.
c
      ecm=einc*em/(emp+em)
      aksq = emu * ecm
      ak = sqrt (aksq)
      grel=1.d0

      go to 22
c
c     relativistic kinematics.  schrodinger equation is written with
c     reduced mass and ak.  ecm does not appear.  the choice for the
c     relativistic correction concerns the choice made for the
c     reduced mass and ak.  the factor grel is the ratio of the
c     relativistic reduced mass to the nonrelativistic reduced mass.
c
c     model 1 ---
c
c     ak is chosen as ingemarsson, physica scripta vol. 9, p. 156
c     (1974), expression (17).  the reduced mass is formed from
c     the relativistic masses of target and projectile in the c.m.
c     system.
c
    5 xemp=amen*emp
      xem =amen*em
      xemt=xemp+xem
      aux=2.d0*xem*einc
      wcm=sqrt(xemt*xemt+aux)
      temp=einc*(einc+2.d0*xemp)
      ak=sqrt(temp)*xem/(197.32d0*wcm)
      aksq=ak*ak
      x=aux/(xemt*xemt)
      if(x.gt.1.e-3) go to 8
      ecm=(.0625d0*x*x*x-.125d0*x*x+.5d0*x)*xemt
      go to 10
    8 ecm=wcm-xemt
c
   10 wm=xem*(einc+xemt)/wcm
      wmp=wcm-wm
      grel=wmp*wm/((wmp+wm)*amen*amu)
      aknn=sqrt(.5d0*xemp*einc)/197.32d0

c
   20 amu=grel*amu
      emu=grel*emu
c
   22 zzp=.034447d0*amu*z*zp
      eta = zzp/ak
      if (eta .lt. 0.d0) go to 905
c
      write(lout,105)einc,ecm,ak,grel
  105 format(' einc,ecm,ak,grel'//1p4e13.4//)
c
      return
c
c     error returns.
c
  905 kerr=1
      write(lout,9050)
 9050 format(//' eta is negative')
      return
c
      end
