      subroutine prepgl
c     ********************************************8
c     calculation of the Gauss-Legendre coeff.
c     calculation of  Ylm on the  GL mesh
c     *********************************************
      implicit none
      include 'gl_com.inc'
      include 'pi_com.inc'

      real*8 tm1(32),tm2(32),tst,sqr,sqr1
      real*8 sdot
      real*8 cosi,cosi2,cosi4,cosi6,cosi8
      real*8 xpl5,xpl6,xpl7,xpl8,xpl9,xpl10
      integer*4 ita,ii,jj,kk

c     npgl=16
      npgl=1
      
      if(npgl.eq.1)then
         xg(1)=0.0d0
         wg(1)=1.0d0
      endif

      if(npgl.eq.16)then
         XG(1)=0.04830766568773800d0                                       
         XG(2)=0.14447196158279600d0                                       
         XG(3)=0.23928736225213700d0                                       
         XG(4)=0.33186860228212700d0                                       
         XG(5)=0.42135127613063500d0                                       
         XG(6)=0.50689990893222900d0                                       
         XG(7)=0.58771575724076200d0                                       
         XG(8)=0.66304426693021500d0                                       
         XG(9)=0.73218211874028900d0                                       
         XG(10)=0.79448379596794200d0                                      
         XG(11)=0.84936761373256900d0                                      
         XG(12)=0.89632115576605200d0                                      
         XG(13)=0.93490607593773900d0                                      
         XG(14)=0.96476225558750600d0                                      
         XG(15)=0.98561151154526800d0                                      
         XG(16)=0.99726386184948100d0                                      
         WG(1)=0.09654008851472700d0                                       
         WG(2)=0.09563872007927400d0                                       
         WG(3)=0.09384439908080400d0                                       
         WG(4)=0.09117387869576300d0                                       
         WG(5)=0.08765209300440300d0                                       
         WG(6)=0.08331192422694600d0                                       
         WG(7)=0.07819389578707000d0                                       
         WG(8)=0.07234579410884800d0                                       
         WG(9)=0.06582222277636100d0                                       
         WG(10)=0.05868409347853500d0                                      
         WG(11)=0.05099805926237600d0                                      
         WG(12)=0.04283589802222600d0                                      
         WG(13)=0.03427386291302100d0                                      
         WG(14)=0.02539206530926200d0                                      
         WG(15)=0.01627439473090500d0                                      
         WG(16)=0.00701861000947000d0
      endif

      SQR=DSQRT(4.25d0/PI)
      sqr1=dsqrt(21.d0/(4.d0*pi))
      DO 300 ita=1,npgl                                                  
      COSI=XG(ita)                                                     
      COSI2=COSI*COSI                                                 
      COSI4=COSI2*COSI2                                               
      COSI6=COSI2*COSI4                                               
      COSI8=COSI2*COSI6                                               
      PLL(ita,1)=1.0d0                                                   
      PLL(ita,2)=0.63078310d0*(1.5d0*COSI2-0.50d0)                           
      PLL(ita,3)=0.846284367d0*(4.375d0*COSI4-3.75d0*COSI2+0.375d0)             
      PLL(ita,4)=1.017107d0*(14.4375d0*COSI6
     &  -19.6875d0*COSI4+6.5625d0*COSI2     
     &   -0.3125d0)                                                         
      PLL(ita,5)=SQR*(50.2734375d0*COSI8-93.84375d0*COSI6
     &   +54.140625d0*COSI4   
     &   -9.84375d0*COSI2+0.2734375d0)  
      xpl5=cosi*(63.*cosi4-70.*cosi2+15.)/8.d0
      xpl6=(231.*cosi6-315.*cosi4+105.*cosi2-5.)/16.d0
      xpl7= (13d0*cosi*xpl6-6d0*xpl5)/7.d0
      xpl8= (15d0*cosi*xpl7-7d0*xpl6)/8.d0
      xpl9= (17d0*cosi*xpl8-8d0*xpl7)/9.d0
      xpl10=(19d0*cosi*xpl9-9d0*xpl8)/10.d0
      PLL(ita,6)=sqr1*xpl10

  300 CONTINUE         

c     normalisation des Ylm
      do jj=2,6
        do ii=1,npgl
           pll(ii,jj)=pll(ii,jj)*dsqrt(4.0*pi)
        enddo
      enddo
      return
      end
