      subroutine readin
c     version as of 10/09/01.
c
c     ******************************************************************
c
c     subroutine for reading in data. for each run, as many cards as
c     are required to change the parameters from the previous run may
c     be submitted.  a blank card terminates the readin. another blank
c     card should be placed at the end of the entire input deck.
c
c     initial values for many of the parameters are established in
c     the data statements below.
c
c     ******************************************************************
c
      implicit none
      character*12 namop0,namesk,namepp,namenn
      character*8 label
      character*1 khtest,khin
c
      include 'mai1_com.inc'
      include 'mai2_com.inc'
      include 'gsdn_com.inc'
      include 'nams_com.inc' 
      include 'alfs_com.inc'
      include 'sfrl_com.inc'
      include 'jlms_com.inc'
      include 'kmas_com.inc'
      include 'lams_com.inc'
      include 'ltra_com.inc'
      include 'vcinp_com.inc'
c
c
      real*8 temp(7),einc0,einc1,rden0
      dimension label(10),khtest(31)
      integer*4 i
c
      data khtest/1h ,1ha,1hb,1hc,1hd,1he,1hf,1hg,1hh,1hi,1hj,1hk,
     &    1hl,1hm,1hn,1ho,1hp,1hq,1hr,1hs,1ht,1hu,1hv,1hw,1hx,1hy,1hz,
     &    1hA,1hB,1hC,1hD/
c
c   b

c   d
      data einc0,einc1/0.d0,0.d0/
c   j

c   k
      data rden0/0.d0/
c   z
c
c     note -- all formats are at the end.
c
c     read and print label to identify the run.
c     if label is blank, terminate.  this is normal program exit.
c
      read (lin,1000) label
      if(label(1).ne.'        ') go to 10
c
      call exit(0)
c
c     read name of output file for optical potentials and name of
c     input file for self-consistent wave number.  if output file
c     name is blank, use file left over from previous case.
c
   10 read(lin,1007)namop0,namesk,namepp,namenn
      if(namop0.eq.'            '.or.namop0.eq.nameop) go to 12
      nameop=namop0
      close(lopt)
      open(unit=lopt,file=nameop)
c
c     get date and time of day for beginning of this case.
c
c   12 call datime(today,clock)
 12   continue
c
      write(lout,1001)
c
c      write(lout,1002)today,clock,(label(i),i=1,10)
c
      write(lout,1003)namei,nameo,nameop,namegd
c
c     read the input data.
c
c     check the first character on each record against the table
c     khtest, then branch to code which stores the input data
c     in the proper variables.  if the character is not in the table,
c     an error message is printed along with the bad record.  on reading
c     a blank or end of file, write the data on lun lout and return.
c
      write(lout,1004)
   20 read (lin,1006) khin,(temp(i),i=1,7)
      if(khin.ne.' ') write(lout,1005)khin,(temp(i),i=1,7)
      do 40 i = 1,31
      if(khin.eq.khtest(i)) go to (255,100,105,110,115,120,125,
     & 130,135,140,145,150,155,160,165,170,175,180,185,190,195,
     & 200,205,210,215,220,225,227,229,231,233),i
   40 continue
      go to 900
c
c     identifier is a.
c
  100 continue
c      npts   = temp(1)
      go to 20
c
c     identifier is b.
c
  105 continue
      zp     = temp(1)
      go to 20
c
c     identifier is c.
c
  110 continue
      z      = temp(1)
      a      = temp(2)
      go to 20
c
c     identifier is d.
c
  115 continue
      einc0  = temp(1)
      einc1  = temp(2)
      go to 20
c
c     identifier is e.
c
  120 continue
      irel   = temp(1)
      go to 20
c
c     identifier is f.
c
  125 continue

      go to 20
c
c     identifier is g.
c
  130 continue
      go to 20
c
c     identifier is h.
c
  135 continue

      go to 20
c
c     identifier is i.
c
  140 continue
c      ispor  = temp(1)
      go to 20
c
c     identifier is j.
c
  145 continue


      go to 20
c
c     identifier is k.
c
  150 continue
      nptdn  = temp(2)
      rden0  = temp(3)
      go to 20
c
c     identifier is l.
c
  155 continue

      go to 20
c
c     identifier is m.
c
  160 continue

      go to 20
c
c     identifier is n.
c
  165 continue

      go to 20
c
c     identifier is o.
c
  170 continue
      al0r   = temp(1)

      altr   = temp(3)

      go to 20
c
c     identifier is p.
c
  175 continue
      al0i   = temp(1)

      alti   = temp(3)

      go to 20
c
c     identifier is q.
c     not in use
  180 continue

      go to 20
c
c     identifier is r.
c
  185 continue

      go to 20
c
c     identifier is s.
c
  190 continue
      go to 20
c
c     identifier is t.
c
  195 continue

      go to 20
c
c     identifier is u.
c
  200 continue
      tjlmr  = temp(1)
      tjlmi  = temp(2)

      icorv  = temp(5)
      icorw  = temp(6)

      go to 20
c
c     identifier is v.
c
  205 continue
      kmw    = temp(1)
      go to 20
c
c     identifier is w.
c
  210 continue
      xlv    = temp(1)
      xlw    = temp(2)
      go to 20
c
c     identifier is x.
c
  215 continue

      go to 20
c
c     identifier is y.
c
  220 continue

      go to 20
c
c     identifier is z.
c
  225 continue
      go to 20
c
c     id A
c
 227  continue
      go to 20
c
c     id B
c
 229  continue
      go to 20
c
c     id C
c
 231  continue
      go to 20
C
c     id D
c
 233  continue
      go to 20

c
c     blank record has been read.  print input data on lun lout.
c
  255 continue
c
c
      einc=einc0+einc1

      write(lout,*) '  '
      
      write(lout,'(1h a,3f7.1)') 'z,a,zp: ',z,a,zp
      write(lout, '(1h a,f8.5)')'einc: ',einc
      write(lout,'(1h a,4f10.6)')'al0r,al0i,altr,alti: ',
     &                                  al0r,al0i,altr,alti
      write(lout,'(1h a,2f8.5)') 'xlv,xlw: ',xlv,xlw
      write(lout,*) 'icorv,icorw: ',icorv,icorw
      write(lout,'(1h a,2f8.5)') 'tjlmr,tjlmi: ',tjlmr,tjlmi 
      write(lout,*) 'kmw: ',kmw
      write(lout,*) 'irel : ', irel
      write(lout,*) 'npts: ',npts
c
      rden=rden0
      if(rden.eq.0.d0) rden=20.d0
      if(rden.lt.radmax) go to 901
c
c
      rmax=npts*h
      if(zp.eq.0.d0) emp=1.0087d0
      if(zp.eq.1.d0) emp=1.0073d0
      em=a

c
c
      write(lout,1050)
c     	
      return
c
c     error messages.
c
  900 write(lout,9000) khin,temp
      call exit(1)
  901 write(lout,9001)
      call exit(1)
  902 write(lout,9002)
      call exit(1)
  904 write(lout,9004)
      call exit(1)
c
c     formats
c
 1000 format(10a8)
 1001 format('1'/' program  M O M  '//)
 1002 format(' date/time of run ',2a10///1x,10a8//)
 1003 format(' input file name  ',a/
     &       ' output file name  ',a/
     &       ' optical potential file name  ',a/
     &       ' ground-state density file name  ',a//)
 
 1004 format(' input cards for this case'/)
 1005 format(5x,a1,2x,1p7e15.6)
 1006 format(a1,7f10.0)
 1007 format(4(a12,3x))
 1008 format(30x,f15.0)
 1010 format(i5)
 1020 format(' potential or form factor constructed from proton and',
     & ' neutron potentials read in from files  ',a12,2x,a12)
 1050 format(//)
 9000 format (/' error in readin --- input data error'/
     & 1x,a1,1p7e13.3/)
 9001 format(/' error in readin --- rden.lt.radmax'/)
 9002 format(/' error in readin --- nptsx.ne.npts'/)
 9004 format(/' error -- jlm cannot be used in this calculation'/)
      end
