      subroutine xform
c     13/09/01
c     **************************************************************
c     calculate the density in (r,theta) coordinate from the (r,l) ones
c     trivial for l=0
c     really useful in deformed densities
c     included in this program only for code base compatibility with
c     full-fledged code
c     **************************************************************

      implicit none

      include 'mai1_com.inc'
      include 'gsdn_com.inc'
      include 'jlms_com.inc'
      include 'vang1_com.inc' 
      include 'rho1_com.inc'
      include 'gl_com.inc'
      include 'vcinp_com.inc'
      include 'lamx_com.inc'
      include 'pi_com.inc'

      real*8 alf,rho,anorm
      integer*4 lamax1,ix,ita,ipol,i,j

      lamax1 = lamax

      DO ita=1,32                                                  
         DO IX=1,200                                                 
            valf(ix,ita)=0.0d0
            VANG(IX,ita)=0.0d0                                                 
         enddo
      enddo

      anorm = 1.0d0
      do ita=1,npgl
        do ix=1,npts
          do ipol=1,lamax1
             rho=rhopi(ix,ipol)+rhoni(ix,ipol)
             alf=rhoni(ix,ipol)-rhopi(ix,ipol)
             vang(ix,ita)=vang(ix,ita)+rho*pll(ita,ipol)*anorm            
             valf(ix,ita)=valf(ix,ita)+alf*pll(ita,ipol)*anorm
          enddo
        enddo
      enddo

      do i=1,npts
         do j=1,npgl
            valf(i,j)=valf(i,j)/vang(i,j)
         enddo
      enddo 

      return
      end
